/* note that the .js is necassary to:
- create the loop (teleport)
- create the start-end-view clone
- dragging on the floor
*/

/* CUSTOM PROPERTIES
  ========================================================================== */

/* section cut is the amount of "half" section we see on the right side */
:root {
  --sections-in-view: 3;
  --section-cut: calc(var(--lh-s) * 6);
}

@media (max-width: 72rem) {
  :root {
    --sections-in-view: 2;
    --section-cut: calc(var(--lh-s) * 4);
  }
}

@media (max-width: 42rem) {
  :root {
    --sections-in-view: 1;
    --section-cut: calc(var(--lh-s) * 2);
  }
}

/* WRAPPING
  ========================================================================== */
/* we need a body > wrapper combinaition because the bottom scroll bar
takes place that can varry, thus only putting a div to 100vh take too much places */
body.home {
  background: var(--clr-back);

  height: 100vh;
  overflow-x: hidden;
}

.scrolling-ring {
  height: 100%;
  overflow-x: auto;

  /* + we put tabindex="0" on the html so the focus is on it directly
  when we arrive on the page and can use the arrows to scroll */
}
.scrolling-ring:focus,
.scrolling-ring:focus-visible{
  outline: none;
}

/* WALLS/FLOOR SEPARATION
  ========================================================================== */
.scrolling-ring{
  display: grid;
  grid-template-columns: min-content;
  grid-template-rows: 1fr auto;

  /*
  NOTE: the floor element has not be a descendant of the .ring-space-cut,
  otherwise it has an ancestor with overflow-x: hidden which cancels
  the sticky to its left, so we make the separation before
  */
}
.ring-space-wrapper{
  min-height: 0;
}

.floor {
  background: var(--clr-dark-back);

  box-sizing: border-box;
  width: 100vw;

  position: sticky;
  left: 0;

  cursor: e-resize;
}

/* SECTIONS WIDTH AND CUT OF THE RING-SPACE
  ========================================================================== */

/*
the cut is a fixed em distance (so we have control over which part of the
cutted section we see
(w * siv) + c = 100vw
w = (100vw - c) / siv
*/

.ring-space-wrapper{
  /* a wrapper */

  /* by default it's same width than its parent: 100vw.
  we change it so its width is computed according to its descendants */
  width: fit-content;

  --section-width: calc((100vw - var(--section-cut)) / var(--sections-in-view));
}

.ring-space-cut {
  /* where the cut happen */
  height: 100%;

  /* the cut need to happen between the content and the wrapper,
  because if we use 100% in .ring-space-wrapper it'll refer to the width of
  the parent which is 100vw, using 100% here refers to
  .ring-space-wrapper width which depends on .content */

  /* so we can cut it of the amount we want with a negative margin */
  max-width: 100%;
  margin-right: calc((var(--section-width) - var(--section-cut)) * -1);
  overflow-x: hidden;
}

.ring-section{
  box-sizing: border-box;
  width: var(--section-width);
}

.ring-section > h2{
  text-transform: lowercase;
  font-style: italic;
  font-weight: normal;
  text-decoration: underline;
}


/* SECTIONS STRUCTURE & STYLING
  ========================================================================== */

.ring-space{
  height: 100%;

  /* for semi section (a grid in a grid) */
  display: grid;
  grid-template-rows: 50% 50%;
  grid-auto-flow: column dense;
}

.ring-space > .ring-section {
  /* we have to disable flex-shrinking */
  overflow-y: auto;
  overflow-x: hidden;

  /* by default take both rows */
  grid-row-end: span 2;

  border-right: var(--border);
}

/* FLOOR
  ========================================================================== */

footer.floor{
  display: flex;
  align-items: baseline;
  justify-content: space-between;
}

ul.main-nav{
  list-style: none;
  padding: 0;
  margin: 0;

  display: flex;
  justify-content: flex-end;

  gap: var(--lh);
  margin-left: var(--lh);
}

/* PROJECTS LIST
  ========================================================================== */

ul.articles-list{
  list-style: none;
  padding-left: 0;

  margin-top: var(--lh);

  border-top: var(--border);
  border-top-style: dotted;

  /* margin-left: calc(-1 * var(--lh));
  margin-right: calc(-1 * var(--lh));*/
}
ul.articles-list > li{
  margin: calc(var(--lh) * 1) 0;
}

ul.articles-list h3{
  margin: 0;
  font-weight: normal;
}

ul.articles-list header{
  display: grid;
  grid-template-columns: 1fr auto;
  gap: 0 calc(var(--lh) / 2);
}

ul.tags{
  grid-column: 1 / -1;
}

@media (max-width: 42rem) {
  ul.articles-list header{
    grid-template-columns: 1fr;
  }
}

/* IMAGES
  ========================================================================== */

.ring-section img {
  max-width: 100%;
  max-height: 33vh;
  margin: 0 auto;
  border: var(--border);
  border-color: var(--clr-border-fun);
}

/* SECTIONS ORDER / COMPO
  ========================================================================== */

.ring-space > .ring-section--half{
  grid-row-end: span 1;
  border-top: var(--border);
  margin-top: calc(-1 * var(--border-width));
}

/* specific
  ========================================================================== */

#color{
  display: flex;
  flex-direction: column;
}
#my-favorite-color-display{
  background: var(--clr-fav);
  border-radius: 50%;
  flex-grow: 1;
}